/*
 * File name: MatrixExtended.java
 * Date:      2014/11/10 19:10
 * Author:    Jan Faigl
 */
package cz.cvut.fel.pr1;

public class MatrixExtended extends Matrix {

    public MatrixExtended(int rows, int cols) {
        super(rows, cols);
    }

    @Override
    protected Matrix createMatrix(int rows, int cols) {
        return new MatrixExtended(rows, cols);
    }

    @Override
    public Matrix product(Matrix a) {
        final int n = rows;
        if (!(cols == rows && a.rows == n && a.cols == n)) {
            return null;
        }
        Matrix matrixTemp = new Matrix(this);
        double[][] mT = matrixTemp.values;
        double[][] m1 = this.values;
        double[][] m2 = a.values;
        for (int r = 0; r < n; ++r) {
            mT[r][r] = m2[r][r];
            for (int c = r + 1; c < n; ++c) {
                mT[r][c] = m2[c][r];
                mT[c][r] = m2[r][c];
            }
        }
        Matrix ret = createMatrix(this);
        double[][] mr = ret.values;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                mr[i][j] = 0.0;
                for (int k = 0; k < n; ++k) {
                    mr[i][j] += m1[i][k] * mT[j][k];
                }
            }
        }
        return ret;
    }
}
